<template>
  <p>รายการคำร้องขอความช่วยเหลือ</p>
  <div v-if="loaded" class="card">
    <v-infinite-scroll mode="manual" max-height="1000">
      <template v-for="request in helpRequestList" :key="request">
        <v-expansion-panels class="px-1 py-1">
          <v-expansion-panel>
            <v-expansion-panel-title>
              {{ request.attributes.title }}
            </v-expansion-panel-title>
            <div class="d-flex justify-space-between">
              <p class="text-sm ml-3 text-no-wrap">
                คำร้องจาก
                {{ request.attributes.user.data.attributes.prefix }}
                {{ request.attributes.user.data.attributes.firstname }}
                {{ request.attributes.user.data.attributes.lastname }}
              </p>
              <p class="text-id text-end align-self-center pr-2">
                คำร้อง {{ request.id }}
              </p>
            </div>
            <v-expansion-panel-text>
              <p
                v-if="
                  request.attributes.request &&
                  request.attributes.request.data &&
                  request.attributes.request.data.id
                "
                class="text-sm"
              >
                รายการยืม {{ request.attributes.request.data.id }}
              </p>
              <p
                v-if="
                  request.attributes.request &&
                  request.attributes.request.data &&
                  request.attributes.request.data.attributes.equipment &&
                  request.attributes.request.data.attributes.equipment.data &&
                  request.attributes.request.data.attributes.equipment.data
                    .attributes.name
                "
                class="text-sm"
              >
                อุปกรณ์
                {{
                  request.attributes.request.data.attributes.equipment.data
                    .attributes.name
                }}
              </p>
              <p>{{ request.attributes.description }}</p>
              <p class="text-sm">
                ช่องทางติดต่อ ที่อยู่อีเมล
                {{ request.attributes.user.data.attributes.email }}
              </p>
              <v-btn
                @click="onDelete(request.id)"
                :loading="deleteLoading"
                append-icon="mdi-delete"
                class="text-none mt-3"
                color="grey-lighten-3"
                size="small"
                variant="flat"
                block
              >
                ลบ
              </v-btn>
            </v-expansion-panel-text>
          </v-expansion-panel>
        </v-expansion-panels>
      </template>

      <template v-slot:load-more> no more </template>
    </v-infinite-scroll>
  </div>
</template>

<script setup>
useHead({
  title: "ระบบยืม-คืน | คำร้องขอความช่วยเหลือ",
  meta: [{ name: "description", content: "รายการคำร้องขอความช่วยเหลือ" }],
});
definePageMeta({
  middleware: "admin",
});

import { ref, onMounted } from "vue";
import axios from "axios";

const url = useStrapiUrl();
const token = useStrapiToken();

const loaded = ref(false);
const deleteLoading = ref(false);
const requestId = ref();
const helpRequestList = ref([]);

async function onDelete(requestId) {
  deleteLoading.value = true;
  await new Promise((resolve) => setTimeout(resolve, 500));
  deleteLoading.value = false;
  console.log("Request Help ID : ", requestId);

  try {
    await axios.delete(`${url}/helps/${requestId}`, {
      headers: {
        Authorization: `Bearer ${token.value}`,
      },
    });
    gethelpRequestList();
  } catch (error) {
    console.log(error);
  }
}

async function gethelpRequestList() {
  try {
    await axios
      .get(`${url}/helps`, {
        params: {
          populate: {
            request: {
              fields: {
                0: "id",
              },
              populate: {
                equipment: {
                  fields: {
                    1: "name",
                  },
                },
              },
            },
            user: {
              fields: {
                2: "prefix",
                3: "firstname",
                4: "lastname",
                5: "email",
              },
            },
          },
        },
        headers: {
          Authorization: `Bearer ${token.value}`,
        },
      })
      .then((response) => {
        helpRequestList.value = response.data.data;
      });
  } catch (error) {
    console.log(error);
  }
}

onMounted(async () => {
  await gethelpRequestList();
  loaded.value = true;
});
</script>

<style scoped>
p {
  padding: 5px;
}

button {
  font-size: 16px;
}

.card {
  border-radius: 5px;
  background-color: white;
}

.text-id {
  font-size: 12px;
}

.text-sm {
  font-size: 14px;
}
</style>
